import 'package:json_annotation/json_annotation.dart';
import '../image.dart';
import 'info.dart';
import 'spell.dart';
import 'stats.dart';

part 'champion.g.dart';

@JsonSerializable()
class Champion {
  final String id;
  @JsonKey(fromJson: _stringToInt, toJson: _stringFromInt)
  final int key;
  final String name;
  final String title;
  final Image image;
  final String lore;
  final String blurb;
  final List allytips;
  final List enemytips;
  final List tags;
  final String partype;
  final Info info;
  final Stats stats;
  final List<Spell> spells;

  Champion(
      this.id,
      this.key,
      this.name,
      this.title,
      this.image,
      this.lore,
      this.blurb,
      this.allytips,
      this.enemytips,
      this.tags,
      this.partype,
      this.info,
      this.stats,
      this.spells);

  factory Champion.fromJson(Map<String, dynamic> json) =>
      _$ChampionFromJson(json);

  Map<String, dynamic> toJson() => _$ChampionToJson(this);

  static int _stringToInt(String number) =>
      number == null ? null : int.parse(number);

  static String _stringFromInt(int number) => number?.toString();
}
