import 'package:json_annotation/json_annotation.dart';

import '../image.dart';

part 'spell.g.dart';

@JsonSerializable()
class Spell {
  final String id;
  final String name;
  final String description;
  final String tooltip;
  final int maxrank;
  final List<double> cooldown;
  final String cooldownBurn;
  final List<double> cost;
  final String costBurn;
  final List<List<double>> effect;
  final List<String> effectBurn;
  final String costType;
  final String maxammo;
  final List<double> range;
  final String rangeBurn;
  final Image image;
  final String resource;

  Spell(
      this.id,
      this.name,
      this.description,
      this.tooltip,
      this.maxrank,
      this.cooldown,
      this.cooldownBurn,
      this.cost,
      this.costBurn,
      this.effect,
      this.effectBurn,
      this.costType,
      this.maxammo,
      this.range,
      this.rangeBurn,
      this.image,
      this.resource);

  factory Spell.fromJson(Map<String, dynamic> json) => _$SpellFromJson(json);

  Map<String, dynamic> toJson() => _$SpellToJson(this);
}
