import 'package:json_annotation/json_annotation.dart';
import 'gold.dart';
import 'rune.dart';
import 'stats.dart';

part 'item.g.dart';

@JsonSerializable()
class Item {
  final String name;
  final Rune rune;
  final Gold gold;
  final String group;
  final String description;
  final String colloq;
  final String plaintext;
  final bool consumed;
  final int stacks;
  final int depth;
  final bool consumeOnFull;
  final List<String> from;
  final List<String> into;
  final int specialRecipe;
  final bool inStore;
  final bool hideFromAll;
  final String requiredChampion;
  final String requiredAlly;
  final Stats stats;
  final List<String> tags;

  Item(
      this.name,
      this.rune,
      this.gold,
      this.group,
      this.description,
      this.colloq,
      this.plaintext,
      this.consumed,
      this.stacks,
      this.depth,
      this.consumeOnFull,
      this.from,
      this.into,
      this.specialRecipe,
      this.inStore,
      this.hideFromAll,
      this.requiredChampion,
      this.requiredAlly,
      this.stats,
      this.tags);

  factory Item.fromJson(Map<String, dynamic> json) => _$ItemFromJson(json);

  Map<String, dynamic> toJson() => _$ItemToJson(this);
}
